%global pkgname phalcon

Name:           php-phalcon2
Version:        2.0.6 
Release:        1%{?dist}
Summary:        PhalconPHP is a web framework delivered as a C extension 

License:        BSD
URL:            http://phalconphp.com
Source0:        c%{pkgname}-2.0.x.zip
Source1:        %{pkgname}-devtools-2.0.x.zip
Source2:        zephir-master.zip

BuildRequires:  gcc php-devel php-mysql php-pear json-c-devel re2c pcre-devel 
Requires:       php-mysql php-pear php-mbstring php-mcrypt php-openssl php-pdo
Requires:       json-c pcre
Requires:       php(zend-abi) >= 20090626
Requires:       php(api) >= 20090626
Conflicts:      php-phalcon phalconphp

%description
PhalconPHP is a web framework written in C and works as C module.

%prep
%setup -q -n cphalcon-2.0.x
unzip %{SOURCE1}
(cd phalcon-devtools-2.0.x; find * > ../phalcon-devtools-files)
unzip %{SOURCE2}

%build
pushd .
###Build phalcon
cd build
%ifarch i686 i586 i486 i386
cd 32bits
%else
cd 64bits
%endif

phpize
%configure --enable-phalcon
make clean
CFLAGS="-march=native -mtune=native -O2 -fno-delete-null-pointer-checks -finline-functions -fomit-frame-pointer -fno-builtin-memcmp" \
    make %{?_smp_mflags}

###Build zephir
popd
cd zephir-master
cd parser
rm -f *.o *.lo

#Compile lemon
if [ ! -f lemon ]; then
    gcc -w lemon.c -o lemon
fi

re2c -o scanner.c scanner.re && ./lemon -s parser.lemon && cat base.c >> parser.c
if [ ! -f parser.c ]; then
  echo "error: re2c is not installed"
  exit 2
fi

sed s/"\#line"/"\/\/"/g scanner.c > xx && mv -f xx scanner.c
sed s/"#line"/"\/\/"/g parser.c > xx && mv -f xx parser.c
export CFLAGS="-g3 -O0"
gcc -g3 -w parser.c scanner.c -ljson-c -o ../bin/zephir-parser

cd ..
ZEPHIRDIR="%{_datadir}/zephir"
sed "s#%ZEPHIRDIR%#$ZEPHIRDIR#g" bin/zephir > bin/zephir-cmd
chmod 755 bin/zephir-cmd


%install
rm -rf %{buildroot}
%ifarch i686 i586 i486 i386
INSTALL_ROOT=%{buildroot} make -C build/32bits install
%else
INSTALL_ROOT=%{buildroot} make -C build/64bits install
%endif

cat > phalcon.ini << 'EOF'
; Enable phalcon extension module
extension = phalcon.so
EOF
%{__install} -D -m 644 phalcon.ini %{buildroot}%{php_inidir}/phalcon.ini

%{__install} -d -m 755 %{buildroot}%{_datadir}/phalcon-devtools/
%{__cp} -ad ./phalcon-devtools-2.0.x/* %{buildroot}/%{_datadir}/phalcon-devtools/
#%{__install} -d -m 755 %{buildroot}%{_datadir}/phalcon-devtools/docs
#%{__install} -d -m 755 %{buildroot}%{_datadir}/phalcon-devtools/ide
#%{__install} -d -m 755 %{buildroot}%{_datadir}/phalcon-devtools/resources
#%{__install} -d -m 755 %{buildroot}%{_datadir}/phalcon-devtools/templates
#%{__install} phalcon-devtools-2.0.x/{README.md,package.xml,phalcon*,webtools.php} %{buildroot}%{_datadir}/phalcon-devtools/
#%{__install} phalcon-devtools-2.0.x/docs/* %{buildroot}%{_datadir}/phalcon-devtools/docs/
#%{__install} phalcon-devtools-2.0.x/ide/* %{buildroot}%{_datadir}/phalcon-devtools/ide/
#%{__install} phalcon-devtools-2.0.x/resources/* %{buildroot}%{_datadir}/phalcon-devtools/resources/
#%{__install} phalcon-devtools-2.0.x/templates/* %{buildroot}%{_datadir}/phalcon-devtools/templates/

%{__install} -d 755 %{buildroot}%{_bindir}
(cd %{buildroot}%{_bindir}; ln -sfn ../..%{_datadir}/phalcon-devtools/phalcon.sh phalcon)

%{__install} -d 755 %{buildroot}%{_datadir}/zephir
%{__cp} -ad ./zephir-master/* %{buildroot}/%{_datadir}/zephir/
%{__install} %{buildroot}%{_datadir}/zephir/bin/zephir-cmd %{buildroot}%{_bindir}/zephir
#(cd %{buildroot}%{_bindir}; ln -sfn ../..%{_datadir}/zephir/zephir-cmd zephir)

%clean
rm -rf %{buildroot}

%files
%defattr(-, root, root, 0755)
%{php_extdir}/phalcon.so
%config(noreplace) %{php_inidir}/phalcon.ini

%doc CHANGELOG.md README.md CONTRIBUTING.md docs/*

%{_bindir}/phalcon
%{_bindir}/zephir
%{_datadir}/phalcon-devtools
%{_datadir}/zephir

%changelog
* Fri Nov 22 2013 Yasuo Ohgaki <yohgaki@ohgaki.net>
- Initial build.
